---------------------------------------------------------------------------
-- This VHDL file was developed by Daniel Llamocca (2013).  It may be
-- freely copied and/or distributed at no cost.  Any persons using this
-- file for any purpose do so at their own risk, and are responsible for
-- the results of such use.  Daniel Llamocca does not guarantee that
-- this file is complete, correct, or fit for any particular purpose.
-- NO WARRANTY OF ANY KIND IS EXPRESSED OR IMPLIED.  This notice must
-- accompany any copy of this file.
--------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
ENTITY tb_mydec2to4 IS
END tb_mydec2to4;
 
ARCHITECTURE behavior OF tb_mydec2to4 IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT mydec2to4
    PORT(
         w : IN  std_logic_vector(1 downto 0);
         E : IN  std_logic;
         y_a : OUT  std_logic_vector(3 downto 0);
         y_b : OUT  std_logic_vector(3 downto 0);
         y_c : OUT  std_logic_vector(3 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal w : std_logic_vector(1 downto 0) := (others => '0');
   signal E : std_logic := '0';

 	--Outputs
   signal y_a : std_logic_vector(3 downto 0);
   signal y_b : std_logic_vector(3 downto 0);
   signal y_c : std_logic_vector(3 downto 0);

BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: mydec2to4 PORT MAP (
          w => w,
          E => E,
          y_a => y_a,
          y_b => y_b,
          y_c => y_c
        );
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      -- insert stimulus here 
		E <= '1';
		w <= "00"; wait for 20 ns;
		w <= "01"; wait for 20 ns;
		w <= "10"; wait for 20 ns;
		w <= "11"; wait for 20 ns;
		
		E <= '0'; w <= "--";

      wait;
   end process;

END;
